=== debian/changelog ===
fwupdate (9-2) unstable; urgency=medium

  * Add patch to fix compilation with gcc-7. (Closes: #853409)
  * Update build depends to efivar-31 to fix compilation with gcc-7

 -- Mario Limonciello <mario.limonciello@dell.com>  Fri, 04 Aug 2017 16:11:35 -0500

fwupdate (9-1) unstable; urgency=medium

  * New upstream version (9)
  * Add patch to fix compilation.

 -- Mario Limonciello <mario.limonciello@dell.com>  Tue, 07 Mar 2017 19:03:07 -0600
