=== efi/Makefile ===
--- 
+++ 
@@ -1,21 +1,36 @@
 default : all
 
-TOPDIR	?= $(shell pwd)/..
-include $(TOPDIR)/Make.version
-include $(TOPDIR)/Make.defaults
+ifneq	($(origin TOPDIR),undefined)
+TOP     := $(abspath $(TOPDIR))
+else
+TOP     := $(abspath ..)
+endif
+include $(TOP)/Make.defaults
+include $(TOP)/Make.rules
+VPATH	= $(TOP)/efi
 
-CFLAGS		?= -O0 -g3
+CFLAGS	?= -Og -g3 -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 \
+	   -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 \
+	   -grecord-gcc-switches
 BUILDFLAGS	:= $(CFLAGS) -fpic -Werror -Wall -Wextra -fshort-wchar \
 	-fno-merge-constants -ffreestanding \
 	-fno-stack-protector -fno-stack-check --std=gnu11 -DCONFIG_$(ARCH) \
 	-I/usr/include/efi/ -I/usr/include/efi/$(ARCH)/ \
-	-iquote$(TOPDIR)/include "-DDEBUGDIR=L\"$(DEBUGDIR)/\""
+	-iquote$(TOP)/include "-DDEBUGDIR=L\"$(DEBUGDIR)/\""
 CCLDFLAGS	?= -nostdlib -Wl,--warn-common \
 	-Wl,--no-undefined -Wl,--fatal-warnings \
 	-Wl,-shared -Wl,-Bsymbolic -L$(LIBDIR) -L$(GNUEFIDIR) \
 	-Wl,--build-id=sha1 -Wl,--hash-style=sysv \
 	$(GNUEFIDIR)/crt0-efi-$(ARCH).o
-OBJCOPY_GTE224 = $(shell expr `$(OBJCOPY) --version |grep ^"GNU objcopy" | sed 's/^[^0-9]*//g' | cut -f1-2 -d.` \>= 2.24)
+
+define objcopy_version =
+  $(OBJCOPY) --version |
+    sed -e '/^GNU objcopy/! d;
+	    : loop1; s/([^)(]*)//g;   t loop1;
+	    : loop2; s/\[[^][]*\]//g; t loop2;
+	    s/.* \([0-9][0-9]*\.[0-9][0-9]*\).*/\1/;'
+endef
+OBJCOPY_GTE224 := $(shell expr `$(objcopy_version)` \>= 2.24)
 
 FWUP = fwupdate
 
@@ -52,7 +67,12 @@
 
 all : $(TARGETS)
 
-.SECONDARY: $(foreach target,$(TARGETS),$(target).debug $(target).build-id)
+abidw abicheck :
+
+.SECONDARY: $(foreach target,$(TARGETS),$(target).debug \
+					$(target).build-id \
+					$(target).so \
+					)
 
 $(FWUP).so : fwupdate.so
 	ln -f $< $@
@@ -95,20 +115,21 @@
 	@rm -vf $(TARGETS) *.o *.so *.efi.signed *.efi *.efi.debug \
 		*.efi.build-id
 
-buildiddir = $(dirname $(shell cat $(1).build-id))
+buildiddir = $(dir $(shell cat $(1).build-id))
+buildidname = $(notdir $(shell cat $(1).build-id))
 define inst =
- $(INSTALL) -d -m 755 $(DESTDIR)$(TARGETDIR)
- $(INSTALL) -m 755 $(1) $(DESTDIR)$(TARGETDIR)$(1)
- $(INSTALL) -d -m 755 $(DESTDIR)$(DEBUGINFO)$(TARGETDIR)
+ $(INSTALL) -d -m 755 $(DESTDIR)$(TARGETDIR)/
+ $(INSTALL) -m 755 $(1) $(DESTDIR)$(TARGETDIR)/$(1)
+ $(INSTALL) -d -m 755 $(DESTDIR)$(DEBUGINFO)$(TARGETDIR)/
  $(INSTALL) -m 755 $(1).debug $(DESTDIR)$(DEBUGINFO)$(TARGETDIR)/$(1).debug
- $(INSTALL) -d -m 755 $(DESTDIR)$(DEBUGINFO).build-id/$(dir $(shell cat $(1).build-id))
- ln -sf ../../../../..$(TARGETDIR)$(1) $(DESTDIR)$(DEBUGINFO).build-id/$(shell cat $(1).build-id)
- ln -sf ../..$(TARGETDIR)$(1).debug $(DESTDIR)$(DEBUGINFO).build-id/$(shell cat $(1).build-id).debug
+ $(INSTALL) -d -m 755 $(DESTDIR)$(DEBUGINFO)/.build-id/$(buildiddir)
+ ln -sf ../../../../$(TARGETDIR)/$(1) $(DESTDIR)$(DEBUGINFO)/.build-id/$(buildiddir)/$(buildidname)
+ ln -sf ../../$(TARGETDIR)$(1).debug $(DESTDIR)$(DEBUGINFO)/.build-id/$(buildiddir)/$(buildidname).debug
 endef
 
 install : | check_efidir_error
 install : $(FWUP).efi | $(FWUP).efi.debug $(FWUP).efi.build-id
 	$(INSTALL) -d -m 755 $(DESTDIR)$(TARGETDIR)/fw/
 	$(foreach prog,$^,$(call inst,$(prog)) ; )
-	$(INSTALL) -d -m 755 $(DESTDIR)$(DEBUGSOURCE)fwupdate-$(VERSION)/efi
-	$(foreach src,$(wildcard *.[chS]),$(INSTALL) -m 644 $(src) $(DESTDIR)$(DEBUGSOURCE)fwupdate-$(VERSION)/efi/$(src) ;)
+	$(INSTALL) -d -m 755 $(DESTDIR)$(DEBUGSOURCE)/fwupdate-$(VERSION)$(DASHRELEASE)$(DOTARCH)/efi/
+	$(foreach src,$(wildcard *.[chS]),$(INSTALL) -m 644 $(src) $(DESTDIR)$(DEBUGSOURCE)/fwupdate-$(VERSION)$(DASHRELEASE)$(DOTARCH)/efi/$(src) ;)
