=== debian/changelog ===
fwupdate (10-3) unstable; urgency=medium

  [ Steve Mcintyre ]
  * Move git repo from alioth to salsa.d.o

  [ Mario Limonciello ]
  * Build depend on efivar 34-1 to rebuild against new efivar (LP: #1749471)
  * Bump standards version

 -- Mario Limonciello <mario.limonciello@dell.com>  Wed, 14 Feb 2018 09:57:55 -0600

fwupdate (10-2) unstable; urgency=medium

  * debian/control: Depends on e2fsprogs (Closes: #887290)
  * debian/rules: fix FTCBFS (Closes: #883489)

 -- Mario Limonciello <mario.limonciello@dell.com>  Mon, 15 Jan 2018 09:59:03 -0600

fwupdate (10-1) unstable; urgency=medium

  * New upstream version (10)
  * Drop all patches, now upstream.
  * State directory moved to /var/lib/ from /var/cache
  * Cleanup /var/cache/fwupdate/ on upgrade
  * Require efivar 32-2 or later to build due to UX capsule work.

 -- Mario Limonciello <mario.limonciello@dell.com>  Mon, 08 Jan 2018 17:33:53 -0600

fwupdate (9-3) unstable; urgency=medium

  * Disable "Linux Firmware Updater" boot entry after installation
    (LP: #1730343)
  * update standards version
  * Turn on hardening flags

 -- Mario Limonciello <mario.limonciello@dell.com>  Mon, 06 Nov 2017 09:17:16 -0600
