=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Priority: optional
 Maintainer: Debian EFI <debian-efi@lists.debian.org>
 Uploaders: Daniel Jared Dominguez <jared.dominguez@dell.com>, Steve McIntyre <93sam@debian.org>, Mario Limonciello <mario.limonciello@dell.com>
-Build-Depends: debhelper (>= 9.0.0), pkg-config, libpopt-dev, libefivar-dev (>= 31), libefiboot-dev (>= 31), gnu-efi (>= 3.0.2), elfutils, libsmbios-dev [amd64 i386]
-Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 9.0.0), pkg-config, libpopt-dev, libefivar-dev (>= 34), libefiboot-dev (>= 34), gnu-efi (>= 3.0.2), elfutils, libsmbios-dev [amd64 i386]
+Standards-Version: 4.1.3
 Section: libs
 Homepage: https://github.com/rhinstaller/fwupdate
-Vcs-Git: git://anonscm.debian.org/uefi/fwupdate.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=uefi/fwupdate.git
+Vcs-Git: https://salsa.debian.org/efi-team/fwupdate.git
+Vcs-Browser: https://salsa.debian.org/efi-team/fwupdate
 
 Package: libfwup-dev
 Section: libdevel
@@ -25,7 +25,7 @@
 Section: admin
 Architecture: amd64 i386 armhf arm64
 Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}, libfwup1 (= ${binary:Version}), efibootmgr
+Depends: ${shlibs:Depends}, ${misc:Depends}, libfwup1 (= ${binary:Version}), efibootmgr, e2fsprogs
 Description: Tools to manage UEFI firmware updates
  fwupdate provides functionality to update system firmware. It has been 
  initially designed to update firmware using UEFI capsule updates, but
