=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
EFIDIR ?= $(shell dpkg-vendor --query vendor | awk '{ print tolower($$0) }')
PODATE := $(shell dpkg-parsechangelog --show-field Date | xargs -0 date --utc "+%Y-%m-%d %H:%M%z" --date)

SB_PACKAGE :=
ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
SB_PACKAGE := 1
deb_version	:= $(shell dpkg-parsechangelog | sed -ne "s/^Version: \(.*\)/\1/p")
tar_name	:= fwupdate_$(deb_version)_$(DEB_HOST_ARCH).tar.gz
endif

buildroot	:= debian/tmp


%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
			 libexecdir=\$${prefix}lib/ \
			 datadir=/var/cache/ \
			 localedir=/usr/share/locale/ \
			 GNUEFIDIR=\$${prefix}/lib \
			 CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)- \
			 EFIDIR=$(EFIDIR)
	sed 's,#EFIDIR#,$(EFIDIR),' \
		debian/fwupdate.postrm.in > debian/fwupdate.postrm
	sed 's,#EFIDIR#,$(EFIDIR),' \
		debian/fwupdate.postinst.in > debian/fwupdate.postinst

	# This is to satisfy https://wiki.debian.org/ReproducibleBuilds
	sed -i 's,POT-Creation-Date:.*,POT-Creation-Date: $(PODATE)\\n",' \
		linux/libfwup.po
	sed -i 's,POT-Creation-Date:.*,POT-Creation-Date: $(PODATE)\\n",' \
		linux/fwupdate.po

override_dh_auto_install:
	dh_auto_install -- libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
			   libexecdir=\$${prefix}lib/ \
			   datadir=/var/cache/ \
			   localedir=/usr/share/locale/ \
			   GNUEFIDIR=\$${prefix}/lib \
			   CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)- \
			   EFIDIR=$(EFIDIR)
	chmod -x ${buildroot}/boot/efi/EFI/$(EFIDIR)/*.efi
	cp debian/scripts/install.in   ${buildroot}/usr/lib/fwupdate/install
	sed -i 's,#EFIDIR#,$(EFIDIR),' ${buildroot}/usr/lib/fwupdate/install

override_dh_auto_clean:
	dh_auto_clean -- EFIDIR=$(EFIDIR)
ifneq (,$(SB_PACKAGE))
		rm -rf debian/fwupdate-images
endif

override_dh_builddeb:
	dh_builddeb -- -Zxz
ifneq (,$(SB_PACKAGE))
		mkdir -p debian/fwupdate-images/$(deb_version)
		cp efi/fwup*.efi debian/fwupdate-images/$(deb_version)
		echo $(deb_version) \
			> debian/fwupdate-images/$(deb_version)/version
			cd debian/fwupdate-images && tar czvf ../../../$(tar_name) .
			dpkg-distaddfile $(tar_name) raw-uefi -
endif
