=== docs/Makefile ===
--- 
+++ 
@@ -14,8 +14,11 @@
 	      fwup_resource_iter_next.3 \
 	      fwup_resource_iter_create.3 \
 	      fwup_resource_iter_destroy.3 \
+	      fwup_resource_free.3 \
 	      fwup_set_up_update.3 \
 	      fwup_clear_status.3 \
+	      fwup_set_guid.3 \
+	      fwup_set_guid_forced.3 \
 	      fwup_get_guid.3 \
 	      fwup_get_fw_version.3 \
 	      fwup_get_lowest_supported_version.3 \
@@ -35,12 +38,10 @@
 install : | $(foreach x, $(MAN1TARGETS), $(DESTDIR)$(mandir)/man1/$(x))
 install : | $(foreach x, $(MAN3TARGETS), $(DESTDIR)$(mandir)/man3/$(x))
 
-$(DESTDIR)$(mandir)/man1/%.1 : | mandirs
-$(DESTDIR)$(mandir)/man1/%.1 : %.1
+$(DESTDIR)$(mandir)/man1/%.1 : %.1 | mandirs
 	$(INSTALL) -m 644 $< $@
 
-$(DESTDIR)$(mandir)/man3/%.3 : | mandirs
-$(DESTDIR)$(mandir)/man3/%.3 : %.3
+$(DESTDIR)$(mandir)/man3/%.3 : %.3 | mandirs
 	$(INSTALL) -m 644 $< $@
 
 .PHONY: all clean test install mandirs
