=== efi/Makefile ===
--- 
+++ 
@@ -13,6 +13,7 @@
 	   -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 \
 	   -grecord-gcc-switches
 BUILDFLAGS	:= $(CFLAGS) -fpic -Werror -Wall -Wextra -fshort-wchar \
+	-Wno-error=missing-field-initializers -Wno-missing-field-initializers \
 	-fno-merge-constants -ffreestanding \
 	-fno-stack-protector -fno-stack-check --std=gnu11 -DCONFIG_$(ARCH) \
 	-I/usr/include/efi/ -I/usr/include/efi/$(ARCH)/ \
@@ -22,6 +23,11 @@
 	-Wl,-shared -Wl,-Bsymbolic -L$(LIBDIR) -L$(GNUEFIDIR) \
 	-Wl,--build-id=sha1 -Wl,--hash-style=sysv \
 	$(GNUEFIDIR)/crt0-efi-$(ARCH).o
+CLANG_BUGS	= $(if $(findstring gcc,$(CC)),-maccumulate-outgoing-args,)
+LIBGCC=$(shell $(CC) -print-libgcc-file-name)
+ifeq ($(ARCH),arm)
+LIBGCC+=" $(shell $(CC) -print-libgcc-file-name | sed 's/\.a$/_eh.a/')"
+endif
 
 define objcopy_version =
   $(OBJCOPY) --version |
@@ -37,14 +43,14 @@
 ifeq ($(ARCH),x86_64)
 	FORMAT = --target efi-app-$(ARCH)
 	BUILDFLAGS += -mno-mmx -mno-sse -mno-red-zone -nostdinc \
-		-maccumulate-outgoing-args -DEFI_FUNCTION_WRAPPER \
+		$(CLANG_BUGS) -DEFI_FUNCTION_WRAPPER \
 		-DGNU_EFI_USE_MS_ABI -I$(shell $(CC) -print-file-name=include)
 	FWUP = fwupx64
 endif
 ifeq ($(ARCH),ia32)
 	FORMAT = --target efi-app-$(ARCH)
 	BUILDFLAGS += -mno-mmx -mno-sse -mno-red-zone -nostdinc \
-		-maccumulate-outgoing-args -m32 \
+		$(CLANG_BUGS) -m32 \
 		-I$(shell $(CC) -print-file-name=include)
 	FWUP = fwupia32
 endif
@@ -105,7 +111,7 @@
 
 %.so : %.o
 	$(CC) $(CCLDFLAGS) -o $@ $^ -lefi -lgnuefi \
-		$(shell $(CC) -print-libgcc-file-name) \
+		$(LIBGCC) \
 		-T elf_$(ARCH)_efi.lds
 
 %.o : %.c
