=== linux/Makefile ===
--- 
+++ 
@@ -34,6 +34,7 @@
 BUILDFLAGS := $(CFLAGS) -Wall -Wextra -Werror -Wno-error=cpp \
 	-Wno-unused-result -Wno-unused-function \
 	-Wsign-compare -Werror=sign-compare \
+	-Wno-error=missing-field-initializers -Wno-missing-field-initializers \
 	-fshort-wchar --std=gnu11 \
 	-DLOCALEDIR=\"$(localedir)\" -D_GNU_SOURCE \
 	-DFWUP_EFI_DIR_NAME=\"$(EFIDIR)\"  \
@@ -47,7 +48,7 @@
 LIBTARGETS=libfwup.so
 PCTARGETS=fwup.pc
 POTARGETS = fwupdate.po libfwup.po
-TARGETS=$(BINTARGETS) $(INCTARGETS) $(foreach x,$(LIBTARGETS),$(x) $(x).1 $(x).1.$(VERSION)) $(PCTARGETS) $(POTARGETS) libfwup.so cleanup.service cleanup
+TARGETS=$(BINTARGETS) $(INCTARGETS) $(foreach x,$(LIBTARGETS),$(patsubst %.so,%.map,$(x)) $(x).1.$(VERSION) $(x).1 $(x)) $(PCTARGETS) $(POTARGETS) cleanup.service cleanup
 
 .SUFFIXES:
 
@@ -60,22 +61,31 @@
 		$(INSTALL) -d -m 755 include ; \
 	fi
 
+fwupdate.c : | include/fwup.h
 libfwup.c : | include/fwup.h
 include/fwup.h : | include/fwup-version.h
 include/fwup-version.h : | include-dir
 
-abidw : $(patsubst %.so,%.abixml,$(LIBTARGETS))
-	git add $^
+abicheck : | clean $(LIBTARGETS)
+abicheck : $(patsubst %.so,%.abicheck,$(LIBTARGETS))
 
-abicheck : $(patsubst %.so,%.abicheck,$(LIBTARGETS))
+abiclean :
+	@rm -vf $(patsubst %.so,%.abixml,$(LIBTARGETS))
+
+abixml : | $(LIBTARGETS)
+abixml : $(patsubst %.so,%.abixml,$(LIBTARGETS))
+
+abiupdate : abixml
+	git add $(patsubst %.so,%.abixml,$(LIBTARGETS))
 
 % : %.o
 	$(CC) $(BUILDFLAGS) -o $@ $(patsubst lib%.so,-l%,$^) $(BIN_CCLDFLAGS)
 
-%.so.1.$(VERSION) : %.o
+%.so.1.$(VERSION) : %.o | %.map
 	$(CC) $(BUILDFLAGS) \
 		-Wl,-soname,$(patsubst %.o,%.so.1,$<) \
-		-o $@ $^ $(LIB_CCLDFLAGS)
+		-Wl,--version-script=$(patsubst %.o,%.map,$<) \
+		-o $@ $< $(LIB_CCLDFLAGS)
 
 %.so.1 : %.so.1.$(VERSION)
 	ln -sf $< $@
@@ -90,26 +100,29 @@
 	$(CC) $(BUILDFLAGS) -fPIC -c -o $@ $^
 
 % : %.in
-	sed -e "s,@@VERSION@@,$(VERSION),g" \
+	sed -e "s,@@FWUP_VERSION@@,$(VERSION),g" \
 		-e "s,@@FWUP_MAJOR_VERSION@@,$(MAJOR_VERSION),g" \
 		-e "s,@@FWUP_MINOR_VERSION@@,$(MINOR_VERSION),g" \
+		-e "s,@@PREFIX@@,$(prefix),g" \
+		-e "s,@@EXEC_PREFIX@@,$(exec_prefix),g" \
 		-e "s,@@SHAREDSTATEDIR@@,$(sharedstatedir),g" \
 		-e "s,@@ESPMOUNTPOINT@@,$(ESPMOUNTPOINT),g" \
 		-e "s,@@EFIDIR@@,$(EFIDIR),g" \
 		-e "s,@@LIBDIR@@,$(libdir),g" \
 		-e "s,@@LIBEXECDIR@@,$(libexecdir),g" \
+		-e "s,@@INCLUDEDIR@@,$(includedir),g" \
 		$< > $@
 
 tester : tester.c
-	$(CC) -Wall -Werror -ggdb -L. -I./include -I/usr/include/efivar \
-		-lefivar -lfwup -o $@ $^
+	$(CC) -Wall -Werror -ggdb -L. -I./include $(shell $(PKG_CONFIG) --cflags efivar) \
+		$(shell $(PKG_CONFIG) --libs efivar) -lfwup -o $@ $^
 
 test : tester
 	LD_LIBRARY_PATH=$(shell pwd) ./tester
 
 clean :
 	@rm -vf $(BINTARGETS) $(LIBTARGETS) $(PCTARGETS) $(POTARGETS) *.o
-	@rm -vf libfwup.so*
+	@rm -vf libfwup.so* *.map
 	@rm -vf cleanup.service cleanup
 	@rm -vf include/fwup-version.h
 
@@ -134,6 +147,6 @@
 	$(INSTALL) -d -m 755 $(DESTDIR)$(libdatadir)/systemd/system
 	$(INSTALL) -m 644 cleanup.service \
 		$(DESTDIR)$(libdatadir)/systemd/system/fwupdate-cleanup.service
-	$(INSTALL) -d -m 755 $(DESTDIR)/usr/share/bash-completion/completions/
+	$(INSTALL) -d -m 755 $(DESTDIR)$(datadir)/bash-completion/completions/
 	$(INSTALL) -m 755 $(VPATH)/bash-completion \
-		$(DESTDIR)/usr/share/bash-completion/completions/fwupdate
+		$(DESTDIR)$(datadir)/bash-completion/completions/fwupdate
