=== debian/changelog ===
fwupdate (12-7~ubuntu18.04.3) bionic; urgency=medium

  * control: Drop Breaks on libfwup{1,-dev}. (LP: #1820768)

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 19 Dec 2019 19:33:29 +0200

fwupdate (12-7~ubuntu18.04.2) bionic; urgency=medium

  * preinst: Be more thorough when cleaning old files from fwupdate-signed.
  * control: Add fwupdate-signed as a transitional package and drop it from
    fwupdate Breaks. (LP: #1820768)

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 19 Dec 2019 10:46:26 +0200

fwupdate (12-7~ubuntu18.04.1) bionic; urgency=medium

  * Backport to bionic for migration to fwupd. (LP: #1820768)

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 25 Oct 2019 11:27:56 +0300

fwupdate (12-7) unstable; urgency=medium

  * Add a preinst script to clean up extra file from usage. (Closes: #939604)

 -- Mario Limonciello <mario.limonciello@dell.com>  Fri, 06 Sep 2019 17:20:42 -0500

fwupdate (12-6) unstable; urgency=medium

  * Convert package into a transition package (Closes: #925688)

 -- Mario Limonciello <mario.limonciello@dell.com>  Wed, 04 Sep 2019 11:54:50 -0500

fwupdate (12-5) unstable; urgency=medium

  [ Steve McIntyre ]
  * Add Built-Using for the fwupdate-*-signed packages. Closes: #932756

 -- Steve McIntyre <93sam@debian.org>  Mon, 22 Jul 2019 17:31:50 -0300

fwupdate (12-4) unstable; urgency=medium

  [ Steve McIntyre ]
  * debian/gen_signing_json: Update the format of the json metadata to
    match new requirements:
    + Move all the data under a new top-level "packages" key
    + Add an empty "trusted_certs" key - our binaries do not do any
      further verification with an embedded key.

  [ Mario Limonciello ]
  * Install signed packages for secure boot automatically
  * Use a virtual package fwupdate-signed to resolve the correct package
  * Stop producing UEFI archive for Ubuntu signed images (LP: #1787254)

 -- Steve McIntyre <93sam@debian.org>  Mon, 25 Mar 2019 00:47:29 +0000

fwupdate (12-3) unstable; urgency=medium

  * debian/rules: fix libexecdir location (Closes: #905549)

 -- Mario Limonciello <mario.limonciello@dell.com>  Sun, 05 Aug 2018 23:08:34 -0500

fwupdate (12-2) unstable; urgency=medium

  * Bring in a patch from PR https://github.com/rhboot/fwupdate/pull/121
    to resolve FTBFS on armhf.

 -- Mario Limonciello <mario.limonciello@dell.com>  Sat, 04 Aug 2018 23:13:11 -0500

fwupdate (12-1) unstable; urgency=medium

  [ Mario Limonciello ]
  * New upstream version (12)
  * debian/rules:
    - Fix a copy error

  [ Steve Mcintyre ]
  * Initial support for UEFI Secure Boot in Debian infrastructure
    + When building, also generate a fwupdate-$ARCH-signed-template package
      which contains metadata needed by the Debian signing service. This
      will end up being turned into a new source package including a signed
      version of the fwupdate binary.
  * Switch to using dpkg-parsechangelog --show-field in various places -
    don't need sed any more.

  [ Mario Limonciello ]

 -- Steve McIntyre <93sam@debian.org>  Sun, 08 Apr 2018 11:50:28 +0100
