=== debian/control ===
Source: fwupdate
Priority: optional
Maintainer: Debian EFI <debian-efi@lists.debian.org>
Uploaders: Daniel Jared Dominguez <jared.dominguez@dell.com>, Steve McIntyre <93sam@debian.org>, Mario Limonciello <mario.limonciello@dell.com>
Build-Depends: debhelper (>= 9.0.0)
Standards-Version: 4.1.3
Section: libs
Homepage: https://github.com/rhinstaller/fwupdate
Vcs-Git: https://salsa.debian.org/efi-team/fwupdate.git
Vcs-Browser: https://salsa.debian.org/efi-team/fwupdate

Package: fwupdate
Section: admin
Architecture: amd64 i386 armhf arm64
Breaks: fwupdate-amd64-signed-template (<< 12-5),
        fwupdate-i386-signed-template (<< 12-5),
        fwupdate-armhf-signed-template (<< 12-5),
        fwupdate-arm64-signed-template (<< 12-5),
Depends: fwupd
Description: Transitional package for fwupd
 This is a transitional package to move users of fwupdate 12-5 or earlier to fuwpd.

Package: fwupdate-signed
Section: oldlibs
Architecture: amd64 i386 armhf arm64
Depends: fwupd-signed
Description: Transitional package for fwupd
 This is a transitional package to move users of fwupdate-signed to
 fuwpd-signed.
